@import url('https://fonts.googleapis.com/css2?family=Lexend+Deca:wght@100..900&display=swap');

*, *::before, *::after {
    box-sizing: border-box;
}
ul, ol {
    list-style: none;
    margin: 0;
    padding: 0;
}
li {
    list-style: none;
    margin: 0;
    padding: 0;
}

:root {
    font-family: "Lexend Deca", sans-serif;
}

:root[data-theme="light"] {
    --body-background: rgb(246,246,246);
    --body-color: rgb(24,24,24);

    --header-background: rgb(255,255,255);
    --header-border-bottom: 1px solid rgb(230,230,230);
    --header-title-color: rgb(24,24,24);

    --level-title-background: rgb(255,255,255);
    --level-border: 1px solid rgb(230,230,230);
    --level-hover-translate: 0px -5px;
    --level-hover-boxshadow: 0 6px 20px rgba(0, 0, 0, 0.12);

    --main-title-background: rgb(255,255,255);
    --main-title-back-color: rgb(30,30,30);
    --main-title-color: rgb(30,30,30);
    --main-stats-background: rgb(255,255,255);
    --main-stats-border: 1px solid rgb(230,230,230);
    --main-stats-stat-background: #f8fafc;
    --main-stats-stat-border: 1px solid #e2e8f0;
    --main-stats-stat-title-color: #64748b;
    --main-characters-background: rgb(255,255,255);
    --main-image-border: 1px solid rgb(230,230,230);
    --main-character-select-background: rgb(255,255,255);
    --main-character-select-border: 1px solid rgb(230,230,230);
    --main-character-select-choice-hover-background: rgb(0,0,0,0.05);
    --main-leaderboard-background: rgb(255,255,255);
    --main-leaderboard-border: 1px solid rgb(230,230,230);
    --main-leaderboard-table-head-color: #475569;
    --main-leaderboard-table-head-background: #f8fafc;
    --main-leaderboard-table-head-border-bottom: 1px solid #e2e8f0;
    --main-leaderboard-table-data-color: #1e293b;
    --main-leaderboard-table-data-border-bottom: 1px solid #f1f5f9;
    --main-leaderboard-table-title-color: rgb(24,24,24);

    --button-background: rgb(246,246,246,0);
    --button-background-hover: rgb(246,246,246);
    --button-border: 1px solid rgb(230,230,230);
    --button-color: rgb(24,24,24);

    --button-cancel-background: rgb(230,230,230);
    --button-cancel-background-hover: rgb(220,220,220);
    --button-cancel-background-active: rgb(210,210,210);

    --button-confirm-background: #557d63;
    --button-confirm-background-hover: #5f856e;
    --button-confirm-background-active: #639073;

    scrollbar-color: rgb(160,160,160) transparent;
}
:root[data-theme="dark"] {
    --body-background: rgb(24,24,24);
    --body-color: rgb(246,246,246);

    --header-background: rgb(36,36,36);
    --header-border-bottom: 1px solid rgb(80,80,80);
    --header-title-color: rgb(230,230,230);

    --level-title-background: rgb(38,38,38);
    --level-border: 1px solid rgb(60,60,60);
    --level-hover-translate: 0px -5px;
    --level-hover-boxshadow: 0 6px 20px rgba(0,0,0,0.3);

    --main-title-background: rgb(36,36,36);
    --main-title-back-color: rgb(30,30,30);
    --main-title-color: rgb(230,230,230);
    --main-stats-background: rgb(36,36,36);
    --main-stats-border: 1px solid rgb(60,60,60);
    --main-stats-stat-background: rgb(46,46,46);
    --main-stats-stat-border: 1px solid rgb(70,70,70);
    --main-stats-stat-title-color: #a5c1e8;
    --main-characters-background: rgb(36,36,36);
    --main-image-border: 1px solid rgb(36,36,36);
    --main-character-select-background: rgb(36,36,36);
    --main-character-select-border: 1px solid rgb(70,70,70);
    --main-character-select-choice-hover-background: rgb(255,255,255,0.05);
    --main-leaderboard-background: rgb(24,24,24);
    --main-leaderboard-border: 1px solid rgb(60,60,60);
    --main-leaderboard-table-head-color: rgb(200,200,250);
    --main-leaderboard-table-head-background: rgb(44,44,44);
    --main-leaderboard-table-head-border-bottom: 1px solid rgb(70,70,70);
    --main-leaderboard-table-data-color: rgb(230,230,230);
    --main-leaderboard-table-data-border-bottom: 1px solid rgb(70,70,70);
    --main-leaderboard-table-title-color: rgb(230,230,230);

    --button-background: rgb(50,50,50,0);
    --button-background-hover: rgb(50,50,50);
    --button-border: 1px solid rgb(70,70,70);
    --button-color: rgb(230,230,230);

    --button-cancel-background: rgb(230,230,230);
    --button-cancel-background-hover: rgb(220,220,220);
    --button-cancel-background-active: rgb(210,210,210);

    --button-confirm-background: #557d63;
    --button-confirm-background-hover: #5f856e;
    --button-confirm-background-active: #639073;

    scrollbar-color: rgb(100,100,100) transparent;
}

@keyframes circle-in {
    from { clip-path: circle(0% at 50% 0%); }
    to { clip-path: circle(150% at 50% 0%); }
}
::view-transition-old(root) {
    animation: none;
}
::view-transition-new(root) {
    animation: circle-in 500ms ease-in-out both;
}

button {
    font: inherit;
}

html {
    height: 100%;
}

body {
    margin: 0;
    padding: 0;
    min-height: 100%;
    height: fit-content;
    background-color: var(--body-background);
    color: var(--body-color);
    display: flex;
    flex-direction: column;
}

header {
    height: 80px;
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: var(--header-background);
    border-bottom: var(--header-border-bottom);
}
nav {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    max-width: 1100px;
    margin: 0px 16px;
}

#header-title {
    font-size: 1.5rem;
    font-weight: 600;
    color: var(--header-title-color);
    font-family: "Lexend Deca", sans-serif;
    display: flex;
}
#header-title:hover {
    cursor: pointer;
}
#button-theme {
    border: var(--button-border);
    background-color: var(--button-background);
    color: var(--button-color);
    fill: var(--button-color);
    stroke: var(--button-color);
    width: 40px;
    height: 40px;
    display: flex;
    justify-content: center;
    align-items: center;
    border-radius: 4px;
}
#button-theme:hover {
    background-color: var(--button-background-hover);
    cursor: pointer;
}

main {
    flex: 1;
    display: flex;
    justify-content: center;
}

#main-levels {
    width: 100%;
    max-width: 1132px;
    display: none;
    grid-template-columns: repeat(auto-fit, minmax(300px, 1fr));
    gap: 24px;
    padding: 16px;
    align-self: start;
    justify-items: center;
}

.level-card {
    display: block;
    width: 100%;
    max-width: 400px;
    border-radius: 12px;
    background-color: var(--level-title-background);
    border: var(--level-border);
    overflow: hidden;

    transition: box-shadow 0.2s ease-in-out, translate 0.2s ease-in-out;
}
.level-card:hover { 
    cursor: pointer;
    box-shadow: var(--level-hover-boxshadow);
    translate: var(--level-hover-translate);
}

.level-card-img-wrapper {
    display: block;
    width: 100%;
    height: 230px;
}
.level-card-img {
    display: block;
    width: 100%;
    height: 100%;
    object-fit: cover;
}
.level-title {
    font-weight: 600;
    text-align: center;
    font-size: 1.1rem;
    margin: 8px 0;
}
.level-characters {
    width: 100%;
    list-style: none;
    padding: 0;
    margin: 8px 0;
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 8px;
}
.level-character {
    margin: 0;
    padding: 0;
    width: 28px;
    display: block;
    aspect-ratio: 1/1;
    border-radius: 1100px;
}
.level-character > img {
    display: block;
    width: 100%;
    height: 100%;
    object-fit: cover;
}

#main-level {
    display: none;
    padding: 16px;
    width: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
}

#main-title {
    background-color: var(--main-stats-background);
    border: var(--main-stats-border);
    padding: 0 16px;
    border-radius: 8px;
    height: 76px;
    display: flex;
    justify-content: space-between;
    align-items: center; 
    text-transform: uppercase; 
    width: 100%;
    max-width: 1100px;
}
#main-title > li:nth-child(2) {
    flex: 1;
}
#main-title > li:not(:nth-child(2)) {
    width: 40px;
}
#main-title-back {
    text-align: start;
    color: var(--main-title-back-color);
}
#main-title-back > button {
    background-color: var(--button-background);
    color: var(--button-color);
    border: none;
    border-radius: 6px;
    font: inherit;
    width: 40px;
    height: 40px;
    display: block;
    font-size: 1.2rem;
    font-weight: 600;
    display: flex;
    justify-content: center;
    align-items: center;
}
#main-title-back > button > svg {
    stroke-color: var(--button-color);
}
#main-title-back > button:hover {
    cursor: pointer;
    background-color: var(--button-background-hover);
}
#main-title-level {
    text-align: center;
    color: var(--main-title-color);
    font-size: 1.7rem;
    font-weight: 600;  
}

#main-stats {
    margin: 12px 0;
    display: flex;
    justify-content: space-between;
    background-color: var(--main-stats-background);
    border: var(--main-stats-border);
    border-radius: 8px;
    padding: 12px;
    gap: 8px;
    width: 100%;
    max-width: 1100px;
}
#main-stats > li {
    background: var(--main-stats-stat-background);
    border: var(--main-stats-stat-border);
    padding: 8px;
    border-radius: 4px;
    flex: 1;
}
.stat-title {
    text-transform: uppercase;
    font-size: 11px;
    font-weight: 700;
    color: var(--main-stats-stat-title-color);
}
.stat-value {
    margin-top: 4px;
    font-size: 18px;
    font-weight: 600;
}

#main-characters {
    position: sticky;
    z-index: 10;
    top: 8px;
    left: 0;
    height: 56px;
    margin: 12px;
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 8px;
    width: 100%;
    max-width: 1100px;
}
.main-character {
    position: relative;
    height: 100%;
    aspect-ratio: 1/1;
    border-radius: 1000px;
    background-color: var(--main-characters-background);
    border: 2px solid var(--main-characters-background);
    overflow: hidden;
}
.main-character.guessed::after {
    position: absolute;
    left: 0;
    top: 0;
    content: "\2713";
    color: white;
    font-size: 1.25rem;
    font-weight: 700;
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    height: 100%;
    background-color: rgb(0,255,0,0.25);
}
.main-character > img {
    display: block;
    width: 100%;
    height: 100%;
    object-fit: cover;
}

#main-image {
    max-width: 3000px;
    border: var(--main-image-border);
    position: relative;
}
#main-image-img {
    display: block;
    width: 100%;
}
#main-image-img:hover {
    cursor: crosshair;
}
#main-image-cover {
    position: absolute;
    top: 0px;
    left: 0px;
    width: 100%;
    height: 100%;
    background-color: rgb(0,0,0,0.3);
    display: grid;
    grid-template-rows: auto;
    grid-template-columns: auto;
    justify-items: center;
    align-items: center;
    overflow: auto;
}
#main-image-cover-button {
    width: 100%;
    max-width: 200px;
    height: 60px;
    font: inherit;
    border: none;
    border-radius: 6px;
    background-color: white;
    font-size: 1.2rem;
    text-transform: uppercase;
    user-select: none;
    font-weight: 600;
    scale: 1;
    transition: scale ease-out 0.05s;
    box-shadow: 0px 4px 8px rgb(0,0,0,0.2);
}
#main-image-cover-button:hover {
    cursor: pointer;
    background-color: rgb(240,240,240);
}
#main-image-cover-button:active {
    scale: 0.97;
    background-color: rgb(230,230,230);
}
#main-image-cover-result {
    background-color: white;
    color: rgb(30,30,30);
    border-radius: 8px;
    padding: 0 1rem;
    width: 400px;
}
#main-image-result-time {
    margin: 16px 0 8px 0;
    width: 100%;
    text-align: center;
    font-size: 2rem;
    font-weight: 600;
}
#main-image-result-text {
    text-align: center;
    font-size: 1.25rem;
    font-weight: 500;
}
#main-image-cover-result label {
    display: grid;
    width: 100%;
    margin: 16px 0px;
    align-items: center;
    font-weight: 500;
    font-size: 1.1rem;
}
.label-name {
    font-weight: 700;
    color: #334155;
    margin-bottom: 4px;
}
#main-image-cover-result label:has(input:required) .label-name::after {
    content: "*";
    color: red;
    margin-left: 1px;
    font-size: 1rem;
    vertical-align:text-top;
}
#main-image-cover-result label input {
    width: 100%;
    font: inherit;
    border: 1px solid #64748b;
    padding: 8px;
    border-radius: 5px;
    font-weight: 500;
}
#main-image-result-buttons {
    display: flex;
    gap: 8px;
    margin-bottom: 16px;
}
#main-image-result-buttons > button {
    flex: 1;
    font: inherit;
    border-radius: 4px;
    padding: 12px 0;
    border: none;
    font-size: 1.2rem;
    font-weight: 500;
    scale: 1;
    transition: scale ease-out 0.05s;
}
#main-image-result-buttons > button[type="button"] {
    background-color: var(--button-cancel-background);
}
#main-image-result-buttons > button[type="button"]:hover {
    background-color: var(--button-cancel-background-hover);
    cursor: pointer;
}
#main-image-result-buttons > button[type="button"]:active {
    background-color: var(--button-cancel-background-active);
    scale: 0.95;
}
#main-image-result-buttons > button[type="submit"] {
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: var(--button-confirm-background);
    color: white;
}
#main-image-result-buttons > button[type="submit"]:hover {
    background-color: var(--button-confirm-background-hover);
    cursor: pointer;
}
#main-image-result-buttons > button[type="submit"]:active {
    background-color: var(--button-confirm-background-active);
    scale: 0.95;
}

#main-character-select {
    background-color: var(--main-character-select-background);
    border: var(--main-character-select-border);
    border-radius: 8px;
    padding: 8px 0px;
    width: 200px;
    position: absolute;
    left: 0px;
    top: 0px;
    display: none;
}
.main-character-select-choice {
    height: 48px;
    display: flex;
    justify-content: start;
    align-items: center;
    padding: 0px 0px 0px 12px;
    gap: 12px;
}
.main-character-select-choice:hover {
    background-color: var(--main-character-select-choice-hover-background);
    cursor: pointer;
}
.main-character-select-choice > img {
    height: 32px;
}
.main-character-select-name {
    -webkit-user-select: none; 
    -moz-user-select: none;   
    -ms-user-select: none; 
    user-select: none;
}

#main-leaderboard-wrapper {
    margin-top: 16px;
    width: 100%;
    max-width: 1100px;
    display: flex;
    justify-content: center;
}
#main-leaderboard { 
    width: 100%;
    background-color: var(--main-leaderboard-background);
    border: var(--main-leaderboard-border);
    border-radius: 12px;
    overflow: hidden;
}
#main-leaderboard-title {
    color: var(--main-leaderboard-table-title-color);
    font-size: 1.5rem;
    font-weight: 700;
    padding: 24px;
    text-align: center;
    border-bottom: var(--main-leaderboard-table-head-border-bottom);
}
#main-leaderboard-table-wrapper {
    width: 100%;
    overflow: auto;
    scrollbar-width: thin;
}
#main-leaderboard-table {
    min-width: 100%;
    border-collapse: collapse;
}
#main-leaderboard-table thead {
    background: var(--main-leaderboard-table-head-background);
    color: var(--main-leaderboard-table-head-color);
    border-bottom: var(--main-leaderboard-table-head-border-bottom);
}
#main-leaderboard-table th {
    text-transform: uppercase;
    font-weight: 500;
    font-size: 0.9rem;
    padding: 16px;
}
#main-leaderboard-table th:first-of-type {
    text-align: center;
}
#main-leaderboard-table th:not(:first-of-type) {
    text-align: start;
}
#main-leaderboard-table td {
    color: var(--main-leaderboard-table-data-color);
    padding: 16px;
}
#main-leaderboard-table td:first-of-type {
    text-align: center;
}
#main-leaderboard-table td:not(:first-of-type) {
    text-align: start;
}
#main-leaderboard-table tr:not(:last-of-type) {
    border-bottom: var(--main-leaderboard-table-data-border-bottom);
}
#main-leaderboard-table tbody td:nth-child(1) {
    font-size: 1.1rem;
    font-weight: 600;
}
#main-leaderboard-table tbody tr:nth-child(1) td:nth-child(1) {
    color: #eab308;
}
#main-leaderboard-table tbody tr:nth-child(2) td:nth-child(1) {
    color: #94a3b8;
}
#main-leaderboard-table tbody tr:nth-child(3) td:nth-child(1) {
    color: #b45309;
}

footer {
    height: 50px;
    background-color: var(--footer-background);
    border-top: var(--footer-border-top);
    display: flex;
    justify-content: center;
    align-items: center;
}
#footer-title {
    color: var(--footer-title-color);
    font-weight: 300;
}

.modal-info {
    position: fixed;
    bottom: 12px;
    left: 50%;
    display: block;
    opacity: 0;
    pointer-events: none;
    color: white;
    background-color: #475569;
    padding: 12px;
    border-radius: 6px;
    translate: -50% 10px;
    transition: opacity 0.1s ease-out, translate 0.1s ease-out;
    font-weight: 600;
}
.modal-info[open] {
    opacity: 1;
    translate: -50% 0px;
    pointer-events: all;
}

#click-failure-modal {
    background-color: red;
}
#click-success-modal {
    background-color: #6fb86f;
}

.loader {
  width: 24px;
  aspect-ratio: 1;
  border-radius: 50%;
  border: 3px solid currentColor;
  animation:
    l20-1 0.8s infinite linear alternate,
    l20-2 1.6s infinite linear;
}
@keyframes l20-1{
   0%    {clip-path: polygon(50% 50%,0       0,  50%   0%,  50%    0%, 50%    0%, 50%    0%, 50%    0% )}
   12.5% {clip-path: polygon(50% 50%,0       0,  50%   0%,  100%   0%, 100%   0%, 100%   0%, 100%   0% )}
   25%   {clip-path: polygon(50% 50%,0       0,  50%   0%,  100%   0%, 100% 100%, 100% 100%, 100% 100% )}
   50%   {clip-path: polygon(50% 50%,0       0,  50%   0%,  100%   0%, 100% 100%, 50%  100%, 0%   100% )}
   62.5% {clip-path: polygon(50% 50%,100%    0, 100%   0%,  100%   0%, 100% 100%, 50%  100%, 0%   100% )}
   75%   {clip-path: polygon(50% 50%,100% 100%, 100% 100%,  100% 100%, 100% 100%, 50%  100%, 0%   100% )}
   100%  {clip-path: polygon(50% 50%,50%  100%,  50% 100%,   50% 100%,  50% 100%, 50%  100%, 0%   100% )}
}
@keyframes l20-2{ 
  0%    {transform:scaleY(1)  rotate(0deg)}
  49.99%{transform:scaleY(1)  rotate(135deg)}
  50%   {transform:scaleY(-1) rotate(0deg)}
  100%  {transform:scaleY(-1) rotate(-135deg)}
}